using NumberSystemsDLL;

namespace UnitTestDLL
{
	[TestClass]
	public class UnitTestNumberSystems
	{
		/// <summary>
		///    10  16 
		/// </summary>
		[TestMethod]
		public void Convert10To16_Convert1521_return5F1()
		{
			int x = 1521;
			string expected = "5F1";

			NumberSystems obj = new NumberSystems();
			string result = obj.Convert10To16(x);

			Assert.AreEqual(expected, result);
		}

		/// <summary>
		///    16  10 
		/// </summary>
		[TestMethod]
		public void Convert16To10_Convert5F1_return1521()
		{
			string x = "5F1";
			int expected = 1521;

			NumberSystems obj = new NumberSystems();
			int result = obj.Convert16To10(x);

			Assert.AreEqual(expected, result);
		}

		/// <summary>
		///       
		/// </summary>
		[TestMethod]
		public void DictionaryNumberToLetter_Convert10ToChar_returnA()
		{
			int x = 10;
			char expected = 'A';

			NumberSystems obj = new NumberSystems();
			char result = obj.numberToLetter[x];

			Assert.AreEqual(expected, result);
		}

		/// <summary>
		///       
		/// </summary>
		[TestMethod]
		public void DictionaryLetterToNumber_ConvertFToInt_return15()
		{
			char x = 'F';
			int expected = 15;

			NumberSystems obj = new NumberSystems();
			int result = obj.letterToNumber[x];

			Assert.AreEqual(expected, result);
		}
	}
}